package dev.kske.chess;

/**
 * Project: <strong>Chess</strong><br>
 * File: <strong>Move.java</strong><br>
 * Created: <strong>02.07.2019</strong><br>
 * Author: <strong>Kai S. K. Engelbart</strong>
 */
public class Move {

	public final int xPos, yPos, xDest, yDest, xDist, yDist, xSign, ySign;

	public Move(int xPos, int yPos, int xDest, int yDest) {
		this.xPos	= xPos;
		this.yPos	= yPos;
		this.xDest	= xDest;
		this.yDest	= yDest;
		xDist		= Math.abs(xDest - xPos);
		yDist		= Math.abs(yDest - yPos);
		xSign		= (int) Math.signum(xDest - xPos);
		ySign		= (int) Math.signum(yDest - yPos);
	}

	public boolean isHorizontal() { return yDist == 0; }

	public boolean isVertical() { return xDist == 0; }

	public boolean isDiagonal() { return xDist == yDist; }
}
