package dev.kske.chess.piece;

import dev.kske.chess.Board;
import dev.kske.chess.Move;

/**
 * Project: <strong>Chess</strong><br>
 * File: <strong>Pawn.java</strong><br>
 * Created: <strong>01.07.2019</strong><br>
 * Author: <strong>Kai S. K. Engelbart</strong>
 */
public class Pawn extends Piece {

	public Pawn(Color color, Board board) {
		super(color, board);
	}

	@Override
	public boolean isValidMove(Move move) {
		// TODO: Positioning, en passant
		if (getColor() == Color.WHITE)
			return ((move.xDist == 0 && move.yDist > 0 && move.yDist <= 2) || (move.xDist == 1 && move.yDist == 1))
					&& move.ySign == -1 && isFreePath(move);
		else return ((move.xDist == 0 && move.yDist > 0 && move.yDist <= 2) || (move.xDist == 1 && move.yDist == 1))
				&& move.ySign == 1
				&& isFreePath(move);

	}

	@Override
	protected boolean isFreePath(Move move) {
		// Two steps forward
		if (move.yDist == 2)
			return board.getBoardArr()[move.xPos][move.yDest - move.ySign] == null && checkDestination(move);
		// One step forward
		else if (move.xDist == 0) return board.getDest(move) == null;
		// Capture move
		else return board.getDest(move) != null && board.getDest(move).getColor() != getColor();
	}

	@Override
	public Type getType() { return Type.PAWN; }
}
